#include "CommonDialogs.h"
#include "Internals.h"

gchar **strList2Array(char *list)
{
	int count, i;
	gchar *s, **array;
	
	if (!list) return NULL;

	count = 0;
	for (s = list; *s; s+=strlen(s)+1) count++;

	array = (char**) malloc((count+1)*sizeof(gchar*));
	if (!array)
		return NULL;

	i = 0;
	for (s = list; *s; s+=strlen(s)+1) array[i++] = s;
	array[i] = NULL;

	return array;
}

void osRunAboutDialog(char *appName, char *appVersion, char *copyright, char *comments, char *authors, char *documenters, char *translator_credits, BitmapHandle bitmap, WindowHandle owner)
{
	GtkWidget *about;
	gchar **authorsArr, **documentersArr;

	authorsArr     = strList2Array(authors);
	documentersArr = strList2Array(documenters);

	about = gnome_about_new(appName,
	                        appVersion,
	                        copyright,
	                        comments,
	                        authorsArr ? authorsArr : &authorsArr,
	                        documentersArr,
	                        translator_credits,
	                        bitmap->pixbuf);

	if (owner)
		owner = gtk_widget_get_toplevel(owner);
	else
		owner = gFrameWidget;
	gtk_window_set_transient_for(GTK_WINDOW(about), GTK_WINDOW(owner));

	gtk_dialog_run(GTK_DIALOG(about));

	free(documentersArr);
	free(authorsArr);
}
