#include "PopUp.h"
#include "Internals.h"
#include "Handlers_stub.h"

static void handleLBoxClick(GtkList *list, gpointer user_data)
{
	handleControlCommand((GtkWidget *) user_data);
};

WindowHandle osCreatePopUp(WindowHandle window)
{
	GtkWidget *popup;

	popup = gtk_combo_new();
	gtk_entry_set_editable (GTK_ENTRY(GTK_COMBO(popup)->entry), gtk_false());
	gtk_combo_set_use_arrows_always(GTK_COMBO(popup), gtk_true());
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(popup)->entry),
		"changed",
		GTK_SIGNAL_FUNC(handleLBoxClick),
		popup);
	port_layout_put(PORT_LAYOUT(GTK_BIN(window)->child), popup);
	
	return popup;
};

void osAppendPopUpItem(WindowHandle popup, char *title)
{
	GtkWidget *lbox = GTK_COMBO(popup)->list;
	GtkWidget *li = gtk_list_item_new_with_label(title);
	gtk_list_append_items(GTK_LIST(lbox), g_list_append(NULL,li));
	gtk_widget_show(li);
};

void osInsertPopUpItem(WindowHandle popup, int index, char *title)
{
	GtkWidget *lbox = GTK_COMBO(popup)->list;
	GtkWidget *li = gtk_list_item_new_with_label(title);
	gtk_list_insert_items(GTK_LIST(lbox), g_list_append(NULL,li), index);
	gtk_widget_show(li);
};

void osRemovePopUpItem(WindowHandle popup, int index)
{
	GtkWidget *lbox = GTK_COMBO(popup)->list;
	GList *tmp_list = g_list_append(NULL, g_list_nth(GTK_LIST(lbox)->children, index)->data);
	gtk_list_remove_items (GTK_LIST(lbox),tmp_list);
	g_list_free(tmp_list);
};

void osRemoveAllPopUpItems(WindowHandle popup)
{
	GtkWidget *lbox = GTK_COMBO(popup)->list;
	gtk_list_remove_items (GTK_LIST(lbox),GTK_LIST(lbox)->children);
};

void osGetPopUpReqSize(WindowHandle popup, int *res)
{
	GtkRequisition requisition;

	gtk_widget_size_request(popup, &requisition);

	res[0] = requisition.width;
	res[1] = requisition.height;
};

int osGetPopUpSelection(WindowHandle popup)
{
	GtkWidget *lbox = GTK_COMBO(popup)->list;
	if (!GTK_LIST(lbox)->selection)
			return -1;

	return gtk_list_child_position(GTK_LIST(lbox), (GtkWidget *) GTK_LIST(lbox)->selection->data);
};

void osSetPopUpSelection(WindowHandle popup, int index)
{
	GtkWidget *lbox = GTK_COMBO(popup)->list;
	if (index > 0)
		gtk_list_select_item(GTK_LIST(lbox),index);
	else
		gtk_list_unselect_all(GTK_LIST(lbox));
};
