#include "ToolBar.h"
#include "Internals.h"
#include "Handlers_stub.h"
//#include "gtkdropdowntoolbutton.h"

WindowHandle osCreateToolBar(char *name, PositionType place, int band_num, int band_position, int offset)
{
	GtkWidget *toolbar;
	BonoboDockPlacement placement;

	toolbar = gtk_toolbar_new();
	gtk_signal_connect (GTK_OBJECT(toolbar), "destroy",
		GTK_SIGNAL_FUNC(handleWindowDestroy),
		NULL);

	switch (place)
	{
	case PosLeft:   placement = BONOBO_DOCK_LEFT;   break;
	case PosTop:    placement = BONOBO_DOCK_TOP;    break;
	case PosRight:  placement = BONOBO_DOCK_RIGHT;  break;
	case PosBottom: placement = BONOBO_DOCK_BOTTOM; break;
	default: return NULL;
	}

	gnome_app_add_toolbar(GNOME_APP(gFrameWidget),
                                             GTK_TOOLBAR(toolbar),
                                             name,
                                             BONOBO_DOCK_ITEM_BEH_NORMAL,
                                             placement,
                                             band_num,
                                             band_position,
                                             offset);

	return toolbar;
}

void osDestroyToolBar(GtkWidget *toolbar)
{
	gtk_widget_destroy(toolbar);
}

int osGetToolBarButtonCount(WindowHandle toolbar)
{
//	return gtk_toolbar_get_n_items(GTK_TOOLBAR(toolbar));
	printf("osGetToolBarButtonCount -> not implemented for GTK 2.2\n");
	return 0;
}

void tool_button_clicked(GtkWidget *widget, gpointer user_data)
{
	handleToolCommand((ToolHandle) user_data);
}

ToolHandle osInsertToolButton(WindowHandle toolbar, int pos)
{
/*	GtkToolItem *item = gtk_tool_button_new("", gtk_image_new());
	gtk_signal_connect (GTK_OBJECT(GTK_TOOL_BUTTON(item)->button), "clicked",
		GTK_SIGNAL_FUNC(tool_button_clicked),
		item);
	gtk_signal_connect (GTK_OBJECT(item), "destroy",
		GTK_SIGNAL_FUNC(handleToolDestroy),
		NULL);
	gtk_tool_button_set_label_widget(GTK_TOOL_BUTTON(item), gtk_label_new(""));
	gtk_toolbar_insert(GTK_TOOLBAR(toolbar), item, pos);
	gtk_widget_show_all(GTK_WIDGET(item));
	return GTK_WIDGET(item);
*/	
	printf("osInsertToolButton -> not implemented for GTK 2.2\n");
	return NULL;
}

ToolHandle osInsertToolCheckButton(WindowHandle toolbar, int pos)
{
/*	GtkToolItem *item = gtk_toggle_tool_button_new();
	gtk_signal_connect (GTK_OBJECT(GTK_TOOL_BUTTON(item)->button), "clicked",
		GTK_SIGNAL_FUNC(tool_button_clicked),
		item);
	gtk_signal_connect (GTK_OBJECT(item), "destroy",
		GTK_SIGNAL_FUNC(handleToolDestroy),
		NULL);
	gtk_tool_button_set_label_widget(GTK_TOOL_BUTTON(item), gtk_label_new(""));
	gtk_tool_button_set_icon_widget(GTK_TOOL_BUTTON(item), gtk_image_new());

	gtk_toolbar_insert(GTK_TOOLBAR(toolbar), item, pos);
	gtk_widget_show_all(GTK_WIDGET(item));
	return GTK_WIDGET(item);
*/
	printf("osInsertToolCheckButton -> not implemented for GTK 2.2\n");
	return NULL;
}

static void tool_radio_button_clicked(GtkWidget *widget, gpointer user_data)
{
/*	ToolHandle toolItem = (ToolHandle) user_data;

	if (gtk_toggle_tool_button_get_active(GTK_TOGGLE_TOOL_BUTTON(toolItem)))
		handleToolCommand(toolItem);
*/
}

ToolHandle osInsertToolRadioButton(WindowHandle toolbar, int pos)
{
/*	GtkToolItem *item = gtk_radio_tool_button_new(NULL);
	GTK_TOGGLE_BUTTON (GTK_TOOL_BUTTON(item)->button)->active = FALSE;

	gtk_signal_connect (GTK_OBJECT(GTK_TOOL_BUTTON(item)->button), "clicked",
		GTK_SIGNAL_FUNC(tool_radio_button_clicked),
		item);
	gtk_signal_connect (GTK_OBJECT(item), "destroy",
		GTK_SIGNAL_FUNC(handleToolDestroy),
		NULL);
	gtk_tool_button_set_label_widget(GTK_TOOL_BUTTON(item), gtk_label_new(""));
	gtk_tool_button_set_icon_widget(GTK_TOOL_BUTTON(item), gtk_image_new());

	gtk_toolbar_insert(GTK_TOOLBAR(toolbar), item, pos);
	gtk_widget_show_all(GTK_WIDGET(item));
	return GTK_WIDGET(item);
*/
	printf("osInsertToolRadioButton -> not implemented for GTK 2.2\n");
	return NULL;
}

void osSetToolRadioGroup(ToolHandle *handles)
{
/*	ToolHandle *phandle;
	GSList *group = NULL;

	for (phandle = handles; *phandle; phandle++)
	{
		gtk_radio_tool_button_set_group(GTK_RADIO_TOOL_BUTTON(*phandle), group);
		group = gtk_radio_tool_button_get_group(GTK_RADIO_TOOL_BUTTON(*phandle));
	}
*/
	printf("osSetToolRadioGroup -> not implemented for GTK 2.2\n");
}

ToolHandle osInsertToolDropDownButton(WindowHandle toolbar, MenuHandle hmenu, int pos)
{
/*	GtkToolItem *item = gtk_drop_down_tool_button_new();
	gtk_drop_down_tool_button_set_menu(GTK_DROP_DOWN_TOOL_BUTTON(item), hmenu);
	gtk_signal_connect (GTK_OBJECT(item), "destroy",
		GTK_SIGNAL_FUNC(handleToolDestroy),
		NULL);
	gtk_tool_button_set_label_widget(GTK_TOOL_BUTTON(item), gtk_label_new(""));
	gtk_tool_button_set_icon_widget(GTK_TOOL_BUTTON(item), gtk_image_new());
	gtk_toolbar_insert(GTK_TOOLBAR(toolbar), item, pos);
	gtk_widget_show_all(GTK_WIDGET(item));
	return GTK_WIDGET(item);
*/
	printf("osInsertToolDropDownButton -> not implemented for GTK 2.2\n");
	return NULL;
}

ToolHandle osInsertToolLine(WindowHandle toolbar, int pos)
{
/*	GtkToolItem *item = gtk_separator_tool_item_new();
	gtk_signal_connect (GTK_OBJECT(item), "destroy",
		GTK_SIGNAL_FUNC(handleToolDestroy),
		NULL);
	gtk_toolbar_insert(GTK_TOOLBAR(toolbar), item, pos);
	gtk_widget_show_all(GTK_WIDGET(item));
	return GTK_WIDGET(item);
*/
	printf("osInsertToolLine -> not implemented for GTK 2.2\n");
	return NULL;
}

void osSetToolButtonBitmap(ToolHandle toolButton, BitmapHandle bitmap)
{
	//gtk_image_set_from_pixbuf(gtk_tool_button_get_icon_widget (GTK_TOOL_BUTTON(toolButton)), bitmap->pixbuf);
	printf("osSetToolButtonBitmap -> not implemented for GTK 2.2\n");
}

void osSetToolButtonEnabled(ToolHandle toolButton, BOOL enabled)
{
	gtk_widget_set_sensitive(toolButton,enabled);
}

BOOL osGetToolButtonEnabled(ToolHandle toolButton)
{
	return GTK_WIDGET_SENSITIVE(toolButton);
}

void osSetToolButtonTip(ToolHandle toolButton, char *text)
{
	//GtkWidget *toolbar = gtk_widget_get_parent(toolButton);
//	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(toolButton), GTK_TOOLBAR(toolbar)->tooltips, text, NULL);
	printf("osSetToolButtonTip -> not implemented for GTK 2.2\n");
}

char *osGetToolButtonTip(ToolHandle toolButton)
{
/*	GtkTooltipsData *tips_data = gtk_tooltips_data_get(GTK_BIN (toolButton)->child);
	return strdup(tips_data->tip_text);
*/
	printf("osGetToolButtonTip -> not implemented for GTK 2.2\n");
	return NULL;
}

void osSetToolButtonText(ToolHandle toolButton, char *text)
{
//  	GtkWidget *label = gtk_tool_button_get_label_widget (GTK_TOOL_BUTTON(toolButton));
//	gtk_label_set_text(GTK_LABEL(label), text);
	printf("osGetToolButtonTip -> not implemented for GTK 2.2\n");
}

char *osGetToolButtonText(ToolHandle toolButton)
{
/*	GtkWidget *label = gtk_tool_button_get_label_widget (GTK_TOOL_BUTTON(toolButton));
	char *text = gtk_label_get_text(GTK_LABEL(label));
	return strdup(text);*/
	printf("osGetToolButtonText -> not implemented for GTK 2.2\n");
	return NULL;
}

void osSetToolButtonChecked(ToolHandle toolButton, BOOL bState)
{
//	gtk_toggle_tool_button_set_active  (GTK_TOGGLE_TOOL_BUTTON(toolButton), bState);
	printf("osSetToolButtonChecked -> not implemented for GTK 2.2\n");
};

BOOL osGetToolButtonChecked(ToolHandle toolButton)
{
//	return gtk_toggle_tool_button_get_active(GTK_TOGGLE_TOOL_BUTTON(toolButton));
	printf("osGetToolButtonChecked -> not implemented for GTK 2.2\n");
	return FALSE;
};

void osDestroyToolItem(ToolHandle toolItem)
{
	gtk_widget_destroy(toolItem);
}

int osGetToolItemPos(ToolHandle toolItem)
{
//	GtkWidget *toolbar = gtk_widget_get_parent(toolItem);
//	return gtk_toolbar_get_item_index(GTK_TOOLBAR(toolbar), GTK_TOOL_ITEM(toolItem));
	printf("osGetToolItemPos -> not implemented for GTK 2.2\n");
	return 0;
}
