#include <Rts.h>
#include <RtsAPI.h>
#include "Types.h"
#include "Internals.h"
#include "Handlers_stub.h"

GnomeProgram *gProgram = NULL;
int gDocumentInterface;

void *rmalloc (unsigned long bytes)
{
	void *ptr = malloc (bytes);

	if (!ptr)
	{
		printf("rmalloc failed!\n");
		exit(1);
	}

	return ptr;
}

void rfree (void *ptr)
{
	free(ptr);
}

void osInit(char *appName, char *appVersion, int DocumentInterface)
{
	if (!gProgram)
	{
		int margc;
		char **margv;

		gtk_set_locale();
		getProgArgv(&margc, &margv);
		gProgram = gnome_program_init(appName, appVersion, LIBGNOMEUI_MODULE,
                                    margc, margv, GNOME_PARAM_POPT_TABLE, GNOME_PARAM_NONE);

		gAppName    = strdup(appName);
		gAppVersion = strdup(appVersion);
		gDocumentInterface = DocumentInterface;
		gFrameWidget = NULL;
		gClientWidget = NULL;
		gMenuBar = NULL;

		if (gDocumentInterface == 2)
			createMDIFrame();
		else
			createSDIFrame();
	}
};

void osStart()
{
	gtk_main();
	handleProcessDestroy();
	free(gAppName);
	free(gAppVersion);
}

void osQuit()
{
	gtk_widget_destroy(gFrameWidget);
	gtk_main_quit();
	gProgram = NULL;
}

gchar *toMnemonicString(const gchar *source)
{
	gchar *dest = (gchar *) rmalloc(strlen(source)*2+1);
	gchar *s = dest;

	while (*source)
	{
		switch (*source)
		{
		case '&':
			source++;
			*(dest++) = (*source == '&') ? *(source++) : '_';
			break;
		case '_':
			*(dest++) = '_';
		default:
			*(dest++) = *(source++);
		}
	}

	*dest = 0;
	return s;
};

gchar *fromMnemonicString(const gchar *source)
{
	gchar *dest = (gchar *) rmalloc(strlen(source)*2+1);
	gchar *s = dest;

	while (*source)
	{
		switch (*source)
		{
		case '_':
			source++;
			*(dest++) = (*source == '_') ? *(source++) : '&';
			break;
		case '&':
			*(dest++) = '&';
		default:
			*(dest++) = *(source++);
		}
	}

	*dest = 0;
	return s;
};
