#ifndef ITERNALS_H
#define ITERNALS_H

#include <config.h>

extern BOOL gInKey;
extern int gCurChar;

#include "MenuHandlesMap.h"

#ifndef GET_WHEEL_DELTA_WPARAM
#define GET_WHEEL_DELTA_WPARAM(wparam) ((short)HIWORD (wparam))
#endif

#ifndef NCCALCSIZE_PARAMS
typedef struct tagNCCALCSIZE_PARAMS {
    RECT       rgrc[3];
    PWINDOWPOS lppos;
} NCCALCSIZE_PARAMS, *LPNCCALCSIZE_PARAMS;
#endif

#ifndef TB_GETMAXSIZE
#define TB_GETMAXSIZE           (WM_USER + 83)
#endif

#ifndef TB_SETSTYLE
#define TB_SETSTYLE             (WM_USER + 56)
#endif

#ifndef TB_GETSTYLE
#define TB_GETSTYLE				(WM_USER + 57)
#endif

#ifndef TBSTYLE_EX_MIXEDBUTTONS
#define TBSTYLE_EX_MIXEDBUTTONS 8
#endif

#ifndef TBSTYLE_EX_MIXEDBUTTONS
#define TBSTYLE_EX_MIXEDBUTTONS 8
#endif

#ifndef BTNS_SHOWTEXT
#define BTNS_SHOWTEXT 0x0040
#endif

#ifndef BTNS_WHOLEDROPDOWN
#define BTNS_WHOLEDROPDOWN 0x0080
#endif

#ifndef TBN_DROPDOWN
#define TBN_DROPDOWN            (TBN_FIRST - 10)
#endif

extern HMODULE ghModule;
extern HWND ghWndFrame;

extern unsigned int GetModifiers();

extern WindowHandle checkWindow(HWND hWnd, char *className);

extern void SetupLogBrush(LOGBRUSH *plb, BOOL bSetSolid, int hatchStyle, BitmapHandle patBmp);

typedef struct
{
	HWND hClientWnd;
	int DocumentInterface;
	LPSTR lpszAppName;
	LPSTR lpszAppVersion;
	MenuHandlesMap *pMenuHandlesMap;
	
	HWND hLeftBar, hTopBar, hRightBar, hBottomBar;
} FrameData;

typedef struct
{
	POINT Origin;
	SIZE DomainSize;
	SIZE LineSize, PageSize;
	BOOL bInDragMode;

	COLORREF foreColor;
	COLORREF backColor;
	HBRUSH hBackBrush;
	int hatchStyle;
	BitmapHandle patBmp;

	BOOL enabled;
	int disabledCtrlsCount;
	HWND *disabledCtrls;

	HWND hTooltip;

	SIZE MinTrackSize;
} WindowData;


extern void rfree(void *ptr);
extern void *rmalloc(unsigned long bytes);

void osForceContainerReLayout(HWND hCtrl);

#endif
